/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.78 Revision 1.391
1# Copyright 1999-2004 Gentoo Technologies, Inc. 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.78 2004/02/09 17:08:44 brad_mssw Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.391 2012/04/20 19:35:37 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
14 17
15newdepend "!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
21inherit multilib user
16 22
17DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
18 24
19# This function generate linker scripts in /usr/lib for dynamic 25if has "${EAPI:-0}" 0 1 2; then
20# libs in /lib. This is to fix linking problems when you have
21# the .so in /lib, and the .a in /usr/lib. What happens is that
22# in some cases when linking dynamic, the .a in /usr/lib is used
23# instead of the .so in /lib due to gcc/libtool tweaking ld's
24# library search path. This cause many builds to fail.
25# See bug #4411 for more info.
26#
27# To use, simply call:
28#
29# gen_usr_ldscript libfoo.so
30#
31# Note that you should in general use the unversioned name of
32# the library, as ldconfig should usually update it correctly
33# to point to the latest version of the library present.
34#
35# <azarah@gentoo.org> (26 Oct 2002)
36#
37gen_usr_ldscript() {
38 26
39 # Just make sure it exists 27# @FUNCTION: epause
40 dodir /usr/lib 28# @USAGE: [seconds]
41 29# @DESCRIPTION:
42 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
43/* GNU ld script 31# printing a message the user should probably be reading and often used in
44 Because Gentoo have critical dynamic libraries 32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
45 in /lib, and the static versions in /usr/lib, we 33# don't wait at all. Defined in EAPIs 0 1 and 2.
46 need to have a "fake" dynamic lib in /usr/lib, 34epause() {
47 otherwise we run into linking problems. 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
48 See bug #4411 on http://bugs.gentoo.org/ for
49 more info. */
50GROUP ( /lib/libxxx )
51END_LDSCRIPT
52
53 dosed "s:libxxx:$1:" /usr/lib/$1
54
55 return 0
56} 36}
57 37
58# Simple function to draw a line consisting of '=' the same length as $* 38# @FUNCTION: ebeep
59# 39# @USAGE: [number of beeps]
60# <azarah@gentoo.org> (11 Nov 2002) 40# @DESCRIPTION:
61# 41# Issue the specified number of beeps (default of 5 beeps). Useful when
62draw_line() { 42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
45ebeep() {
63 local i=0 46 local n
64 local str_length="" 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
65 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
66 # Handle calls that do not have args, or wc not being installed ...
67 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
68 then
69 echo "==============================================================="
70 return 0
71 fi
72
73 # Get the length of $*
74 str_length="$(echo -n "$*" | wc -m)"
75
76 while [ "$i" -lt "${str_length}" ]
77 do
78 echo -n "=" 49 echo -ne "\a"
79 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
80 i=$((i + 1)) 51 echo -ne "\a"
52 sleep 1
81 done 53 done
54 fi
55}
82 56
83 echo 57else
84 58
59ebeep() {
60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
61}
62
63epause() {
64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
65}
66
67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
121}
122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
131
132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
85 return 0 169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
86} 184}
87 185
88# Default directory where patches are located 186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
89EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
90# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
91EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
92# Default options for patch 231# @VARIABLE: EPATCH_OPTS
93# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 232# @DESCRIPTION:
233# Options to pass to patch. Meant for ebuild/package-specific tweaking
234# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
235# for single patch tweaking, you can also pass flags directly to epatch.
94EPATCH_OPTS="-g0" 236EPATCH_OPTS=""
237# @VARIABLE: EPATCH_COMMON_OPTS
238# @DESCRIPTION:
239# Common options to pass to `patch`. You probably should never need to
240# change these. If you do, please discuss it with base-system first to
241# be sure.
242# @CODE
243# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
244# --no-backup-if-mismatch - do not leave .orig files behind
245# -E - automatically remove empty files
246# @CODE
247EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
248# @VARIABLE: EPATCH_EXCLUDE
249# @DESCRIPTION:
95# List of patches not to apply. Not this is only file names, 250# List of patches not to apply. Note this is only file names,
96# and not the full path .. 251# and not the full path. Globs accepted.
97EPATCH_EXCLUDE="" 252EPATCH_EXCLUDE=""
253# @VARIABLE: EPATCH_SINGLE_MSG
254# @DESCRIPTION:
98# Change the printed message for a single patch. 255# Change the printed message for a single patch.
99EPATCH_SINGLE_MSG="" 256EPATCH_SINGLE_MSG=""
100# Force applying bulk patches even if not following the style: 257# @VARIABLE: EPATCH_MULTI_MSG
101# 258# @DESCRIPTION:
102# ??_${ARCH}_foo.${EPATCH_SUFFIX} 259# Change the printed message for multiple patches.
103# 260EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
261# @VARIABLE: EPATCH_FORCE
262# @DESCRIPTION:
263# Only require patches to match EPATCH_SUFFIX rather than the extended
264# arch naming style.
104EPATCH_FORCE="no" 265EPATCH_FORCE="no"
105 266
106# This function is for bulk patching, or in theory for just one 267# @FUNCTION: epatch
107# or two patches. 268# @USAGE: [options] [patches] [dirs of patches]
269# @DESCRIPTION:
270# epatch is designed to greatly simplify the application of patches. It can
271# process patch files directly, or directories of patches. The patches may be
272# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
273# the -p option as epatch will automatically attempt -p0 to -p5 until things
274# apply successfully.
108# 275#
109# It should work with .bz2, .gz, .zip and plain text patches. 276# If you do not specify any patches/dirs, then epatch will default to the
110# Currently all patches should be the same format. 277# directory specified by EPATCH_SOURCE.
111# 278#
112# You do not have to specify '-p' option to patch, as it will 279# Any options specified that start with a dash will be passed down to patch
113# try with -p0 to -p5 until it succeed, or fail at -p5. 280# for this specific invocation. As soon as an arg w/out a dash is found, then
281# arg processing stops.
114# 282#
115# Above EPATCH_* variables can be used to control various defaults, 283# When processing directories, epatch will apply all patches that match:
116# bug they should be left as is to ensure an ebuild can rely on 284# @CODE
117# them for. 285# if ${EPATCH_FORCE} != "yes"
118#
119# Patches are applied in current directory.
120#
121# Bulk Patches should preferibly have the form of:
122#
123# ??_${ARCH}_foo.${EPATCH_SUFFIX} 286# ??_${ARCH}_foo.${EPATCH_SUFFIX}
287# else
288# *.${EPATCH_SUFFIX}
289# @CODE
290# The leading ?? are typically numbers used to force consistent patch ordering.
291# The arch field is used to apply patches only for the host architecture with
292# the special value of "all" means apply for everyone. Note that using values
293# other than "all" is highly discouraged -- you should apply patches all the
294# time and let architecture details be detected at configure/compile time.
124# 295#
125# For example: 296# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
297# for patches to apply.
126# 298#
127# 01_all_misc-fix.patch.bz2 299# Refer to the other EPATCH_xxx variables for more customization of behavior.
128# 02_sparc_another-fix.patch.bz2
129#
130# This ensures that there are a set order, and you can have ARCH
131# specific patches.
132#
133# If you however give an argument to epatch(), it will treat it as a
134# single patch that need to be applied if its a file. If on the other
135# hand its a directory, it will set EPATCH_SOURCE to this.
136#
137# <azarah@gentoo.org> (10 Nov 2002)
138#
139epatch() { 300epatch() {
140 local PIPE_CMD="" 301 _epatch_draw_line() {
141 local STDERR_TARGET="${T}/$$.out" 302 # create a line of same length as input string
142 local PATCH_TARGET="${T}/$$.patch" 303 [[ -z $1 ]] && set "$(printf "%65s" '')"
143 local PATCH_SUFFIX="" 304 echo "${1//?/=}"
305 }
306
307 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
308
309 # First process options. We localize the EPATCH_OPTS setting
310 # from above so that we can pass it on in the loop below with
311 # any additional values the user has specified.
312 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
313 while [[ $# -gt 0 ]] ; do
314 case $1 in
315 -*) EPATCH_OPTS+=( "$1" ) ;;
316 *) break ;;
317 esac
318 shift
319 done
320
321 # Let the rest of the code process one user arg at a time --
322 # each arg may expand into multiple patches, and each arg may
323 # need to start off with the default global EPATCH_xxx values
324 if [[ $# -gt 1 ]] ; then
325 local m
326 for m in "$@" ; do
327 epatch "${m}"
328 done
329 return 0
330 fi
331
144 local SINGLE_PATCH="no" 332 local SINGLE_PATCH="no"
145 local x="" 333 # no args means process ${EPATCH_SOURCE}
334 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
146 335
147 if [ "$#" -gt 1 ] 336 if [[ -f $1 ]] ; then
148 then
149 eerror "Invalid arguments to epatch()"
150 die "Invalid arguments to epatch()"
151 fi
152
153 if [ -n "$1" -a -f "$1" ]
154 then
155 SINGLE_PATCH="yes" 337 SINGLE_PATCH="yes"
156 338 set -- "$1"
157 local EPATCH_SOURCE="$1" 339 # Use the suffix from the single patch (localize it); the code
340 # below will find the suffix for us
158 local EPATCH_SUFFIX="${1##*\.}" 341 local EPATCH_SUFFIX=$1
159 342
160 elif [ -n "$1" -a -d "$1" ] 343 elif [[ -d $1 ]] ; then
161 then 344 # Some people like to make dirs of patches w/out suffixes (vim)
162 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 345 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
163 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 346
347 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
348 # Re-use EPATCH_SOURCE as a search dir
349 epatch "${EPATCH_SOURCE}/$1"
350 return $?
351
352 else
353 # sanity check ... if it isn't a dir or file, wtf man ?
354 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
355 echo
356 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
357 eerror
358 eerror " ${EPATCH_SOURCE}"
359 eerror " ( ${EPATCH_SOURCE##*/} )"
360 echo
361 die "Cannot find \$EPATCH_SOURCE!"
362 fi
363
364 # Now that we know we're actually going to apply something, merge
365 # all of the patch options back in to a single variable for below.
366 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
367
368 local PIPE_CMD
369 case ${EPATCH_SUFFIX##*\.} in
370 xz) PIPE_CMD="xz -dc" ;;
371 lzma) PIPE_CMD="lzma -dc" ;;
372 bz2) PIPE_CMD="bzip2 -dc" ;;
373 gz|Z|z) PIPE_CMD="gzip -dc" ;;
374 ZIP|zip) PIPE_CMD="unzip -p" ;;
375 *) ;;
376 esac
377
378 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
379
380 local x
381 for x in "$@" ; do
382 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
383 # didn't match anything, ignore continue on
384 [[ ! -f ${x} ]] && continue
385
386 local patchname=${x##*/}
387
388 # Apply single patches, or forced sets of patches, or
389 # patches with ARCH dependant names.
390 # ???_arch_foo.patch
391 # Else, skip this input altogether
392 local a=${patchname#*_} # strip the ???_
393 a=${a%%_*} # strip the _foo.patch
394 if ! [[ ${SINGLE_PATCH} == "yes" || \
395 ${EPATCH_FORCE} == "yes" || \
396 ${a} == all || \
397 ${a} == ${ARCH} ]]
164 then 398 then
165 local EPATCH_SOURCE="$1/*" 399 continue
400 fi
401
402 # Let people filter things dynamically
403 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
404 # let people use globs in the exclude
405 eshopts_push -o noglob
406
407 local ex
408 for ex in ${EPATCH_EXCLUDE} ; do
409 if [[ ${patchname} == ${ex} ]] ; then
410 eshopts_pop
411 continue 2
412 fi
413 done
414
415 eshopts_pop
416 fi
417
418 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
419 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
420 einfo "${EPATCH_SINGLE_MSG}"
421 else
422 einfo "Applying ${patchname} ..."
423 fi
166 else 424 else
167 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 425 einfo " ${patchname} ..."
426 fi
427
428 # most of the time, there will only be one run per unique name,
429 # but if there are more, make sure we get unique log filenames
430 local STDERR_TARGET="${T}/${patchname}.out"
431 if [[ -e ${STDERR_TARGET} ]] ; then
432 STDERR_TARGET="${T}/${patchname}-$$.out"
433 fi
434
435 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
436
437 # Decompress the patch if need be
438 local count=0
439 local PATCH_TARGET
440 if [[ -n ${PIPE_CMD} ]] ; then
441 PATCH_TARGET="${T}/$$.patch"
442 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
443
444 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
445 echo
446 eerror "Could not extract patch!"
447 #die "Could not extract patch!"
448 count=5
449 break
168 fi 450 fi
451 else
452 PATCH_TARGET=${x}
453 fi
454
455 # Check for absolute paths in patches. If sandbox is disabled,
456 # people could (accidently) patch files in the root filesystem.
457 # Or trigger other unpleasantries #237667. So disallow -p0 on
458 # such patches.
459 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
460 if [[ -n ${abs_paths} ]] ; then
461 count=1
462 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
463 fi
464 # Similar reason, but with relative paths.
465 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
466 if [[ -n ${rel_paths} ]] ; then
467 eqawarn "QA Notice: Your patch uses relative paths '../'."
468 eqawarn " In the future this will cause a failure."
469 eqawarn "${rel_paths}"
470 fi
471
472 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
473 local patch_cmd
474 while [[ ${count} -lt 5 ]] ; do
475 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
476
477 # Generate some useful debug info ...
478 (
479 _epatch_draw_line "***** ${patchname} *****"
480 echo
481 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
482 echo
483 _epatch_draw_line "***** ${patchname} *****"
484 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
485 ret=$?
486 echo
487 echo "patch program exited with status ${ret}"
488 exit ${ret}
489 ) >> "${STDERR_TARGET}"
490
491 if [ $? -eq 0 ] ; then
492 (
493 _epatch_draw_line "***** ${patchname} *****"
494 echo
495 echo "ACTUALLY APPLYING ${patchname} ..."
496 echo
497 _epatch_draw_line "***** ${patchname} *****"
498 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
499 ret=$?
500 echo
501 echo "patch program exited with status ${ret}"
502 exit ${ret}
503 ) >> "${STDERR_TARGET}"
504
505 if [ $? -ne 0 ] ; then
506 echo
507 eerror "A dry-run of patch command succeeded, but actually"
508 eerror "applying the patch failed!"
509 #die "Real world sux compared to the dreamworld!"
510 count=5
511 fi
512 break
513 fi
514
515 : $(( count++ ))
516 done
517
518 # if we had to decompress the patch, delete the temp one
519 if [[ -n ${PIPE_CMD} ]] ; then
520 rm -f "${PATCH_TARGET}"
521 fi
522
523 if [[ ${count} -ge 5 ]] ; then
524 echo
525 eerror "Failed Patch: ${patchname} !"
526 eerror " ( ${PATCH_TARGET} )"
527 eerror
528 eerror "Include in your bugreport the contents of:"
529 eerror
530 eerror " ${STDERR_TARGET}"
531 echo
532 die "Failed Patch: ${patchname}!"
533 fi
534
535 # if everything worked, delete the full debug patch log
536 rm -f "${STDERR_TARGET}"
537
538 # then log away the exact stuff for people to review later
539 cat <<-EOF >> "${T}/epatch.log"
540 PATCH: ${x}
541 CMD: ${patch_cmd}
542 PWD: ${PWD}
543
544 EOF
545 eend 0
546 done
547
548 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
549 : # everything worked
550}
551
552# @FUNCTION: epatch_user
553# @USAGE:
554# @DESCRIPTION:
555# Applies user-provided patches to the source tree. The patches are
556# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
557# of these three directories to exist will be the one to use, ignoring
558# any more general directories which might exist as well. They must end
559# in ".patch" to be applied.
560#
561# User patches are intended for quick testing of patches without ebuild
562# modifications, as well as for permanent customizations a user might
563# desire. Obviously, there can be no official support for arbitrarily
564# patched ebuilds. So whenever a build log in a bug report mentions that
565# user patches were applied, the user should be asked to reproduce the
566# problem without these.
567#
568# Not all ebuilds do call this function, so placing patches in the
569# stated directory might or might not work, depending on the package and
570# the eclasses it inherits and uses. It is safe to call the function
571# repeatedly, so it is always possible to add a call at the ebuild
572# level. The first call is the time when the patches will be
573# applied.
574#
575# Ideally, this function should be called after gentoo-specific patches
576# have been applied, so that their code can be modified as well, but
577# before calls to e.g. eautoreconf, as the user patches might affect
578# autotool input files as well.
579epatch_user() {
580 [[ $# -ne 0 ]] && die "epatch_user takes no options"
581
582 # Allow multiple calls to this function; ignore all but the first
583 local applied="${T}/epatch_user.log"
584 [[ -e ${applied} ]] && return 2
585
586 # don't clobber any EPATCH vars that the parent might want
587 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
588 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
589 EPATCH_SOURCE=${base}/${CTARGET}/${check}
590 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
591 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
592 if [[ -d ${EPATCH_SOURCE} ]] ; then
593 EPATCH_SOURCE=${EPATCH_SOURCE} \
594 EPATCH_SUFFIX="patch" \
595 EPATCH_FORCE="yes" \
596 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
597 epatch
598 echo "${EPATCH_SOURCE}" > "${applied}"
599 return 0
600 fi
601 done
602 echo "none" > "${applied}"
603 return 1
604}
605
606# @FUNCTION: emktemp
607# @USAGE: [temp dir]
608# @DESCRIPTION:
609# Cheap replacement for when debianutils (and thus mktemp)
610# does not exist on the users system.
611emktemp() {
612 local exe="touch"
613 [[ $1 == -d ]] && exe="mkdir" && shift
614 local topdir=$1
615
616 if [[ -z ${topdir} ]] ; then
617 [[ -z ${T} ]] \
618 && topdir="/tmp" \
619 || topdir=${T}
620 fi
621
622 if ! type -P mktemp > /dev/null ; then
623 # system lacks `mktemp` so we have to fake it
624 local tmp=/
625 while [[ -e ${tmp} ]] ; do
626 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
627 done
628 ${exe} "${tmp}" || ${exe} -p "${tmp}"
629 echo "${tmp}"
169 else 630 else
170 if [ ! -d ${EPATCH_SOURCE} ] 631 # the args here will give slightly wierd names on BSD,
171 then 632 # but should produce a usable file on all userlands
172 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 633 if [[ ${exe} == "touch" ]] ; then
173 then 634 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
174 EPATCH_SOURCE="$1"
175 fi
176
177 echo
178 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
179 eerror
180 eerror " ${EPATCH_SOURCE}"
181 echo
182 die "Cannot find \$EPATCH_SOURCE!"
183 fi
184
185 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
186 fi
187
188 case ${EPATCH_SUFFIX##*\.} in
189 bz2)
190 PIPE_CMD="bzip2 -dc"
191 PATCH_SUFFIX="bz2"
192 ;;
193 gz|Z|z)
194 PIPE_CMD="gzip -dc"
195 PATCH_SUFFIX="gz"
196 ;;
197 ZIP|zip)
198 PIPE_CMD="unzip -p"
199 PATCH_SUFFIX="zip"
200 ;;
201 *)
202 PIPE_CMD="cat"
203 PATCH_SUFFIX="patch"
204 ;;
205 esac
206
207 if [ "${SINGLE_PATCH}" = "no" ]
208 then
209 einfo "Applying various patches (bugfixes/updates)..."
210 fi
211 for x in ${EPATCH_SOURCE}
212 do
213 # New ARCH dependant patch naming scheme...
214 #
215 # ???_arch_foo.patch
216 #
217 if [ -f ${x} ] && \
218 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
219 [ "${EPATCH_FORCE}" = "yes" ])
220 then
221 local count=0
222 local popts="${EPATCH_OPTS}"
223
224 if [ -n "${EPATCH_EXCLUDE}" ]
225 then
226 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
227 then
228 continue
229 fi
230 fi
231
232 if [ "${SINGLE_PATCH}" = "yes" ]
233 then
234 if [ -n "${EPATCH_SINGLE_MSG}" ]
235 then
236 einfo "${EPATCH_SINGLE_MSG}"
237 else
238 einfo "Applying ${x##*/}..."
239 fi
240 else
241 einfo " ${x##*/}..."
242 fi
243
244 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
245 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
246
247 # Allow for prefix to differ ... im lazy, so shoot me :/
248 while [ "${count}" -lt 5 ]
249 do
250 # Generate some useful debug info ...
251 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
252 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
253
254 if [ "${PATCH_SUFFIX}" != "patch" ]
255 then
256 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
257 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
258 else
259 PATCH_TARGET="${x}"
260 fi
261
262 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
263 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
264
265 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
266 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
267
268 if [ "${PATCH_SUFFIX}" != "patch" ]
269 then
270 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
271 then
272 echo
273 eerror "Could not extract patch!"
274 #die "Could not extract patch!"
275 count=5
276 break
277 fi
278 fi
279
280 if (cat ${PATCH_TARGET} | patch ${popts} --dry-run -f -p${count}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
281 then
282 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
283 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
284 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
285 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
286 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
287
288 cat ${PATCH_TARGET} | patch ${popts} -p${count} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
289
290 if [ "$?" -ne 0 ]
291 then
292 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
293 echo
294 eerror "A dry-run of patch command succeeded, but actually"
295 eerror "applying the patch failed!"
296 #die "Real world sux compared to the dreamworld!"
297 count=5
298 fi
299
300 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
301
302 break
303 fi
304
305 count=$((count + 1))
306 done
307
308 if [ "${PATCH_SUFFIX}" != "patch" ]
309 then
310 rm -f ${PATCH_TARGET}
311 fi
312
313 if [ "${count}" -eq 5 ]
314 then
315 echo
316 eerror "Failed Patch: ${x##*/}!"
317 eerror
318 eerror "Include in your bugreport the contents of:"
319 eerror
320 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
321 echo
322 die "Failed Patch: ${x##*/}!"
323 fi
324
325 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
326
327 eend 0
328 fi
329 done
330 if [ "${SINGLE_PATCH}" = "no" ]
331 then
332 einfo "Done with patching"
333 fi
334}
335
336# This function return true if we are using the NPTL pthreads
337# implementation.
338#
339# <azarah@gentoo.org> (06 March 2003)
340#
341
342have_NPTL() {
343
344 cat > ${T}/test-nptl.c <<-"END"
345 #define _XOPEN_SOURCE
346 #include <unistd.h>
347 #include <stdio.h>
348
349 int main()
350 {
351 char buf[255];
352 char *str = buf;
353
354 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
355 if (NULL != str) {
356 printf("%s\n", str);
357 if (NULL != strstr(str, "NPTL"))
358 return 0;
359 }
360
361 return 1;
362 }
363 END
364
365 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ... "
366 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
367 then
368 echo "yes"
369 einfon "Checking what PTHREADS implementation we have ... "
370 if ${T}/nptl
371 then
372 return 0
373 else 635 else
374 return 1 636 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
375 fi
376 else
377 echo "no"
378 fi
379
380 return 1
381}
382
383# This function check how many cpu's are present, and then set
384# -j in MAKEOPTS accordingly.
385#
386# Thanks to nall <nall@gentoo.org> for this.
387#
388get_number_of_jobs() {
389 local jobs=0
390
391 if [ ! -r /proc/cpuinfo ]
392 then
393 return 1
394 fi
395
396 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
397 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
398 then
399 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
400 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
401 ADMINPARAM="${ADMINPARAM/-j}"
402 fi
403
404 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
405
406 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
407 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
408 then
409 # these archs will always have "[Pp]rocessor"
410 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
411
412 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
413 then
414 # sparc always has "ncpus active"
415 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
416
417 elif [ "${ARCH}" = "alpha" ]
418 then
419 # alpha has "cpus active", but only when compiled with SMP
420 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
421 then
422 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
423 else
424 jobs=2
425 fi
426
427 elif [ "${ARCH}" = "ppc" -o "${ARCH}" = "ppc64" ]
428 then
429 # ppc has "processor", but only when compiled with SMP
430 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
431 then
432 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
433 else
434 jobs=2
435 fi
436 else
437 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
438 die "Unknown ARCH -- ${ARCH}!"
439 fi
440
441 # Make sure the number is valid ...
442 if [ "${jobs}" -lt 1 ]
443 then
444 jobs=1
445 fi
446
447 if [ -n "${ADMINPARAM}" ]
448 then
449 if [ "${jobs}" -gt "${ADMINPARAM}" ]
450 then
451 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
452 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
453 else
454 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
455 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
456 fi
457 fi
458}
459
460# Cheap replacement for when debianutils (and thus mktemp)
461# do not exist on the users system
462# vapier@gentoo.org
463#
464# Takes just 1 parameter (the directory to create tmpfile in)
465mymktemp() {
466 local topdir="$1"
467
468 [ -z "${topdir}" ] && topdir=/tmp
469 if [ "`which mktemp 2>/dev/null`" ]
470 then
471 mktemp -p ${topdir}
472 else
473 local tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}"
474 touch ${tmp}
475 echo ${tmp}
476 fi
477}
478
479# Simplify/standardize adding users to the system
480# vapier@gentoo.org
481#
482# enewuser(username, uid, shell, homedir, groups, extra options)
483#
484# Default values if you do not specify any:
485# username: REQUIRED !
486# uid: next available (see useradd(8))
487# note: pass -1 to get default behavior
488# shell: /bin/false
489# homedir: /dev/null
490# groups: none
491# extra: comment of 'added by portage for ${PN}'
492enewuser() {
493 # get the username
494 local euser="$1"; shift
495 if [ -z "${euser}" ]
496 then
497 eerror "No username specified !"
498 die "Cannot call enewuser without a username"
499 fi
500
501 # setup a file for testing usernames/groups
502 local tmpfile="`mymktemp ${T}`"
503 chown ${euser} ${tmpfile} >& /dev/null
504 local realuser="`ls -l ${tmpfile} | awk '{print $3}'`"
505
506 # see if user already exists
507 if [ "${euser}" == "${realuser}" ]
508 then
509 return 0
510 fi
511 einfo "Adding user '${euser}' to your system ..."
512
513 # options to pass to useradd
514 local opts=
515
516 # handle uid
517 local euid="$1"; shift
518 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ]
519 then
520 if [ "${euid}" -gt 0 ]
521 then
522 opts="${opts} -u ${euid}"
523 else
524 eerror "Userid given but is not greater than 0 !"
525 die "${euid} is not a valid UID"
526 fi
527 else
528 euid="next available"
529 fi
530 einfo " - Userid: ${euid}"
531
532 # handle shell
533 local eshell="$1"; shift
534 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ]
535 then
536 if [ ! -e "${eshell}" ]
537 then
538 eerror "A shell was specified but it does not exist !"
539 die "${eshell} does not exist"
540 fi
541 else
542 eshell="/bin/false"
543 fi
544 einfo " - Shell: ${eshell}"
545 opts="${opts} -s ${eshell}"
546
547 # handle homedir
548 local ehome="$1"; shift
549 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ]
550 then
551 ehome="/dev/null"
552 fi
553 einfo " - Home: ${ehome}"
554 opts="${opts} -d ${ehome}"
555
556 # handle groups
557 local egroups="$1"; shift
558 if [ ! -z "${egroups}" ]
559 then
560 local realgroup=
561 local oldifs="${IFS}"
562 export IFS=","
563 for g in ${egroups}
564 do
565 chgrp ${g} ${tmpfile} >& /dev/null
566 realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
567 if [ "${g}" != "${realgroup}" ]
568 then
569 eerror "You must add ${g} to the system first"
570 die "${g} is not a valid GID"
571 fi 637 fi
572 done
573 export IFS="${oldifs}"
574 opts="${opts} -g ${egroups}"
575 else
576 egroups="(none)"
577 fi
578 einfo " - Groups: ${egroups}"
579
580 # handle extra and add the user
581 local eextra="$@"
582 local oldsandbox="${SANDBOX_ON}"
583 export SANDBOX_ON="0"
584 if [ -z "${eextra}" ]
585 then
586 useradd ${opts} ${euser} \
587 -c "added by portage for ${PN}" \
588 || die "enewuser failed"
589 else
590 einfo " - Extra: ${eextra}"
591 useradd ${opts} ${euser} ${eextra} \
592 || die "enewuser failed"
593 fi
594 export SANDBOX_ON="${oldsandbox}"
595
596 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
597 then
598 einfo " - Creating ${ehome} in ${D}"
599 dodir ${ehome}
600 fowners ${euser} ${ehome}
601 fperms 755 ${ehome}
602 fi
603}
604
605# Simplify/standardize adding groups to the system
606# vapier@gentoo.org
607#
608# enewgroup(group, gid)
609#
610# Default values if you do not specify any:
611# groupname: REQUIRED !
612# gid: next available (see groupadd(8))
613# extra: none
614enewgroup() {
615 # get the group
616 local egroup="$1"; shift
617 if [ -z "${egroup}" ]
618 then
619 eerror "No group specified !"
620 die "Cannot call enewgroup without a group"
621 fi
622
623 # setup a file for testing groupname
624 local tmpfile="`mymktemp ${T}`"
625 chgrp ${egroup} ${tmpfile} >& /dev/null
626 local realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
627
628 # see if group already exists
629 if [ "${egroup}" == "${realgroup}" ]
630 then
631 return 0
632 fi
633 einfo "Adding group '${egroup}' to your system ..."
634
635 # options to pass to useradd
636 local opts=
637
638 # handle gid
639 local egid="$1"; shift
640 if [ ! -z "${egid}" ]
641 then
642 if [ "${egid}" -gt 0 ]
643 then
644 opts="${opts} -g ${egid}"
645 else
646 eerror "Groupid given but is not greater than 0 !"
647 die "${egid} is not a valid GID"
648 fi 638 fi
649 else
650 egid="next available"
651 fi
652 einfo " - Groupid: ${egid}"
653
654 # handle extra
655 local eextra="$@"
656 opts="${opts} ${eextra}"
657
658 # add the group
659 local oldsandbox="${SANDBOX_ON}"
660 export SANDBOX_ON="0"
661 groupadd ${opts} ${egroup} || die "enewgroup failed"
662 export SANDBOX_ON="${oldsandbox}"
663} 639}
664 640
665# Simple script to replace 'dos2unix' binaries 641# @FUNCTION: edos2unix
666# vapier@gentoo.org 642# @USAGE: <file> [more files ...]
667# 643# @DESCRIPTION:
668# edos2unix(file, <more files>...) 644# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
645# to remove all of these text utilities from DEPEND variables because this
646# is a script based solution. Just give it a list of files to convert and
647# they will all be changed from the DOS CRLF format to the UNIX LF format.
669edos2unix() { 648edos2unix() {
670 for f in "$@" 649 [[ $# -eq 0 ]] && return 0
671 do 650 sed -i 's/\r$//' -- "$@" || die
672 cp "${f}" ${T}/edos2unix
673 sed 's/\r$//' ${T}/edos2unix > "${f}"
674 done
675} 651}
676 652
653# @FUNCTION: make_desktop_entry
654# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
655# @DESCRIPTION:
677# Make a desktop file ! 656# Make a .desktop file.
678# Great for making those icons in kde/gnome startmenu !
679# Amaze your friends ! Get the women ! Join today !
680# gnome2 /usr/share/applications
681# gnome1 /usr/share/gnome/apps/
682# KDE ${KDEDIR}/share/applnk /usr/share/applnk
683# 657#
684# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 658# @CODE
685#
686# binary: what binary does the app run with ? 659# binary: what command does the app run with ?
687# name: the name that will show up in the menu 660# name: the name that will show up in the menu
688# icon: give your little like a pretty little icon ... 661# icon: give your little like a pretty little icon ...
689# this can be relative (to /usr/share/pixmaps) or 662# this can be relative (to /usr/share/pixmaps) or
690# a full path to an icon 663# a full path to an icon
691# type: what kind of application is this ? for categories: 664# type: what kind of application is this?
692# http://www.freedesktop.org/standards/menu/draft/menu-spec/menu-spec.html 665# for categories:
693# path: if your app needs to startup in a specific dir 666# http://standards.freedesktop.org/menu-spec/latest/apa.html
667# if unset, function tries to guess from package's category
668# fields: extra fields to append to the desktop file; a printf string
669# @CODE
694make_desktop_entry() { 670make_desktop_entry() {
695 [ -z "$1" ] && eerror "You must specify the executable" && return 1 671 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
696 672
697 local exec="${1}" 673 local exec=${1}
698 local name="${2:-${PN}}" 674 local name=${2:-${PN}}
699 local icon="${3:-${PN}.png}" 675 local icon=${3:-${PN}}
700 local type="${4}" 676 local type=${4}
701 local path="${5:-${GAMES_PREFIX}}" 677 local fields=${5}
678
702 if [ -z "${type}" ] 679 if [[ -z ${type} ]] ; then
703 then 680 local catmaj=${CATEGORY%%-*}
704 case ${CATEGORY} in 681 local catmin=${CATEGORY##*-}
705 "app-emulation") 682 case ${catmaj} in
706 type=Emulator 683 app)
684 case ${catmin} in
685 accessibility) type="Utility;Accessibility";;
686 admin) type=System;;
687 antivirus) type=System;;
688 arch) type="Utility;Archiving";;
689 backup) type="Utility;Archiving";;
690 cdr) type="AudioVideo;DiscBurning";;
691 dicts) type="Office;Dictionary";;
692 doc) type=Documentation;;
693 editors) type="Utility;TextEditor";;
694 emacs) type="Development;TextEditor";;
695 emulation) type="System;Emulator";;
696 laptop) type="Settings;HardwareSettings";;
697 office) type=Office;;
698 pda) type="Office;PDA";;
699 vim) type="Development;TextEditor";;
700 xemacs) type="Development;TextEditor";;
701 esac
707 ;; 702 ;;
708 "games-"*) 703
709 type=Game 704 dev)
705 type="Development"
710 ;; 706 ;;
711 "net-"*) 707
712 type=Network; 708 games)
709 case ${catmin} in
710 action|fps) type=ActionGame;;
711 arcade) type=ArcadeGame;;
712 board) type=BoardGame;;
713 emulation) type=Emulator;;
714 kids) type=KidsGame;;
715 puzzle) type=LogicGame;;
716 roguelike) type=RolePlaying;;
717 rpg) type=RolePlaying;;
718 simulation) type=Simulation;;
719 sports) type=SportsGame;;
720 strategy) type=StrategyGame;;
721 esac
722 type="Game;${type}"
713 ;; 723 ;;
724
725 gnome)
726 type="Gnome;GTK"
727 ;;
728
729 kde)
730 type="KDE;Qt"
731 ;;
732
733 mail)
734 type="Network;Email"
735 ;;
736
737 media)
738 case ${catmin} in
739 gfx)
740 type=Graphics
741 ;;
742 *)
743 case ${catmin} in
744 radio) type=Tuner;;
745 sound) type=Audio;;
746 tv) type=TV;;
747 video) type=Video;;
748 esac
749 type="AudioVideo;${type}"
750 ;;
751 esac
752 ;;
753
754 net)
755 case ${catmin} in
756 dialup) type=Dialup;;
757 ftp) type=FileTransfer;;
758 im) type=InstantMessaging;;
759 irc) type=IRCClient;;
760 mail) type=Email;;
761 news) type=News;;
762 nntp) type=News;;
763 p2p) type=FileTransfer;;
764 voip) type=Telephony;;
765 esac
766 type="Network;${type}"
767 ;;
768
769 sci)
770 case ${catmin} in
771 astro*) type=Astronomy;;
772 bio*) type=Biology;;
773 calc*) type=Calculator;;
774 chem*) type=Chemistry;;
775 elec*) type=Electronics;;
776 geo*) type=Geology;;
777 math*) type=Math;;
778 physics) type=Physics;;
779 visual*) type=DataVisualization;;
780 esac
781 type="Education;Science;${type}"
782 ;;
783
784 sys)
785 type="System"
786 ;;
787
788 www)
789 case ${catmin} in
790 client) type=WebBrowser;;
791 esac
792 type="Network;${type}"
793 ;;
794
714 *) 795 *)
715 type= 796 type=
716 ;; 797 ;;
717 esac 798 esac
718 fi 799 fi
719 local desktop="${T}/${exec}.desktop" 800 if [ "${SLOT}" == "0" ] ; then
801 local desktop_name="${PN}"
802 else
803 local desktop_name="${PN}-${SLOT}"
804 fi
805 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
806 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
720 807
808 # Don't append another ";" when a valid category value is provided.
809 type=${type%;}${type:+;}
810
811 eshopts_push -s extglob
812 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
813 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
814 ewarn "allowed in .desktop files if the value is not an absolute path."
815 icon=${icon%.@(xpm|png|svg)}
816 fi
817 eshopts_pop
818
819 cat <<-EOF > "${desktop}"
721echo "[Desktop Entry] 820 [Desktop Entry]
722Encoding=UTF-8
723Version=0.9.2
724Name=${name} 821 Name=${name}
725Type=Application 822 Type=Application
726Comment=${DESCRIPTION} 823 Comment=${DESCRIPTION}
727Exec=${exec} 824 Exec=${exec}
728Path=${path} 825 TryExec=${exec%% *}
729Icon=${icon} 826 Icon=${icon}
730Categories=Application;${type};" > ${desktop} 827 Categories=${type}
828 EOF
731 829
732 if [ -d "/usr/share/applications" ] 830 if [[ ${fields:-=} != *=* ]] ; then
733 then 831 # 5th arg used to be value to Path=
832 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
833 fields="Path=${fields}"
834 fi
835 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
836
837 (
838 # wrap the env here so that the 'insinto' call
839 # doesn't corrupt the env of the caller
734 insinto /usr/share/applications 840 insinto /usr/share/applications
735 doins ${desktop} 841 doins "${desktop}"
736 fi 842 ) || die "installing desktop file failed"
843}
737 844
738 #if [ -d "/usr/share/gnome/apps" ] 845# @FUNCTION: validate_desktop_entries
739 #then 846# @USAGE: [directories]
740 # insinto /usr/share/gnome/apps/Games 847# @MAINTAINER:
741 # doins ${desktop} 848# Carsten Lohrke <carlo@gentoo.org>
742 #fi 849# @DESCRIPTION:
743 850# Validate desktop entries using desktop-file-utils
744 #if [ ! -z "`ls /usr/kde/* 2>/dev/null`" ] 851validate_desktop_entries() {
745 #then 852 if [[ -x /usr/bin/desktop-file-validate ]] ; then
746 # for ver in /usr/kde/* 853 einfo "Checking desktop entry validity"
747 # do 854 local directories=""
748 # insinto ${ver}/share/applnk/Games 855 for d in /usr/share/applications $@ ; do
749 # doins ${desktop} 856 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
750 # done 857 done
751 #fi 858 if [[ -n ${directories} ]] ; then
752 859 for FILE in $(find ${directories} -name "*\.desktop" \
753 if [ -d "/usr/share/applnk" ] 860 -not -path '*.hidden*' | sort -u 2>/dev/null)
754 then 861 do
755 insinto /usr/share/applnk/${type} 862 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
756 doins ${desktop} 863 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
864 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
865 done
757 fi 866 fi
758 867 echo ""
759 return 0
760}
761
762# for internal use only (unpack_pdv and unpack_makeself)
763find_unpackable_file() {
764 local src="$1"
765 if [ -z "${src}" ]
766 then
767 src="${DISTDIR}/${A}"
768 else 868 else
769 if [ -e "${DISTDIR}/${src}" ] 869 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
770 then 870 fi
771 src="${DISTDIR}/${src}" 871}
772 elif [ -e "${PWD}/${src}" ] 872
773 then 873# @FUNCTION: make_session_desktop
774 src="${PWD}/${src}" 874# @USAGE: <title> <command> [command args...]
775 elif [ -e "${src}" ] 875# @DESCRIPTION:
776 then 876# Make a GDM/KDM Session file. The title is the file to execute to start the
777 src="${src}" 877# Window Manager. The command is the name of the Window Manager.
878#
879# You can set the name of the file via the ${wm} variable.
880make_session_desktop() {
881 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
882 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
883
884 local title=$1
885 local command=$2
886 local desktop=${T}/${wm:-${PN}}.desktop
887 shift 2
888
889 cat <<-EOF > "${desktop}"
890 [Desktop Entry]
891 Name=${title}
892 Comment=This session logs you into ${title}
893 Exec=${command} $*
894 TryExec=${command}
895 Type=XSession
896 EOF
897
898 (
899 # wrap the env here so that the 'insinto' call
900 # doesn't corrupt the env of the caller
901 insinto /usr/share/xsessions
902 doins "${desktop}"
903 )
904}
905
906# @FUNCTION: domenu
907# @USAGE: <menus>
908# @DESCRIPTION:
909# Install the list of .desktop menu files into the appropriate directory
910# (/usr/share/applications).
911domenu() {
912 (
913 # wrap the env here so that the 'insinto' call
914 # doesn't corrupt the env of the caller
915 local i j ret=0
916 insinto /usr/share/applications
917 for i in "$@" ; do
918 if [[ -f ${i} ]] ; then
919 doins "${i}"
920 ((ret+=$?))
921 elif [[ -d ${i} ]] ; then
922 for j in "${i}"/*.desktop ; do
923 doins "${j}"
924 ((ret+=$?))
925 done
926 else
927 ((++ret))
928 fi
929 done
930 exit ${ret}
931 )
932}
933
934# @FUNCTION: newmenu
935# @USAGE: <menu> <newname>
936# @DESCRIPTION:
937# Like all other new* functions, install the specified menu as newname.
938newmenu() {
939 (
940 # wrap the env here so that the 'insinto' call
941 # doesn't corrupt the env of the caller
942 insinto /usr/share/applications
943 newins "$@"
944 )
945}
946
947# @FUNCTION: doicon
948# @USAGE: <list of icons>
949# @DESCRIPTION:
950# Install the list of icons into the icon directory (/usr/share/pixmaps).
951# This is useful in conjunction with creating desktop/menu files.
952doicon() {
953 (
954 # wrap the env here so that the 'insinto' call
955 # doesn't corrupt the env of the caller
956 local i j ret
957 insinto /usr/share/pixmaps
958 for i in "$@" ; do
959 if [[ -f ${i} ]] ; then
960 doins "${i}"
961 ((ret+=$?))
962 elif [[ -d ${i} ]] ; then
963 for j in "${i}"/*.png ; do
964 doins "${j}"
965 ((ret+=$?))
966 done
967 else
968 ((++ret))
969 fi
970 done
971 exit ${ret}
972 )
973}
974
975# @FUNCTION: newicon
976# @USAGE: <icon> <newname>
977# @DESCRIPTION:
978# Like all other new* functions, install the specified icon as newname.
979newicon() {
980 (
981 # wrap the env here so that the 'insinto' call
982 # doesn't corrupt the env of the caller
983 insinto /usr/share/pixmaps
984 newins "$@"
985 )
986}
987
988# @FUNCTION: strip-linguas
989# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
990# @DESCRIPTION:
991# Make sure that LINGUAS only contains languages that
992# a package can support. The first form allows you to
993# specify a list of LINGUAS. The -i builds a list of po
994# files found in all the directories and uses the
995# intersection of the lists. The -u builds a list of po
996# files found in all the directories and uses the union
997# of the lists.
998strip-linguas() {
999 local ls newls nols
1000 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1001 local op=$1; shift
1002 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1003 local d f
1004 for d in "$@" ; do
1005 if [[ ${op} == "-u" ]] ; then
1006 newls=${ls}
1007 else
1008 newls=""
778 fi 1009 fi
779 fi 1010 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
780 [ ! -e "${src}" ] && die "Could not find requested archive ${src}" 1011 if [[ ${op} == "-i" ]] ; then
781 echo "${src}" 1012 has ${f} ${ls} && newls="${newls} ${f}"
782} 1013 else
783 1014 has ${f} ${ls} || newls="${newls} ${f}"
784# Unpack those pesky pdv generated files ... 1015 fi
785# They're self-unpacking programs with the binary package stuffed in 1016 done
786# the middle of the archive. Valve seems to use it a lot ... too bad 1017 ls=${newls}
787# it seems to like to segfault a lot :(. So lets take it apart ourselves. 1018 done
788#
789# Usage: unpack_pdv [file to unpack] [size of off_t]
790# - you have to specify the off_t size ... i have no idea how to extract that
791# information out of the binary executable myself. basically you pass in
792# the size of the off_t type (in bytes) on the machine that built the pdv
793# archive. one way to determine this is by running the following commands:
794# strings <pdv archive> | grep lseek
795# strace -elseek <pdv archive>
796# basically look for the first lseek command (we do the strings/grep because
797# sometimes the function call is _llseek or something) and steal the 2nd
798# parameter. here is an example:
799# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
800# lseek
801# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
802# lseek(3, -4, SEEK_END) = 2981250
803# thus we would pass in the value of '4' as the second parameter.
804unpack_pdv() {
805 local src="`find_unpackable_file $1`"
806 local sizeoff_t="$2"
807
808 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :("
809
810 local shrtsrc="`basename ${src}`"
811 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
812 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
813 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
814
815 # grab metadata for debug reasons
816 local metafile="`mymktemp ${T}`"
817 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
818
819 # rip out the final file name from the metadata
820 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
821 datafile="`basename ${datafile}`"
822
823 # now lets uncompress/untar the file if need be
824 local tmpfile="`mymktemp ${T}`"
825 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
826
827 local iscompressed="`file -b ${tmpfile}`"
828 if [ "${iscompressed:0:8}" == "compress" ] ; then
829 iscompressed=1
830 mv ${tmpfile}{,.Z}
831 gunzip ${tmpfile}
832 else 1019 else
833 iscompressed=0 1020 ls="$@"
1021 fi
1022
1023 nols=""
1024 newls=""
1025 for f in ${LINGUAS} ; do
1026 if has ${f} ${ls} ; then
1027 newls="${newls} ${f}"
1028 else
1029 nols="${nols} ${f}"
834 fi 1030 fi
835 local istar="`file -b ${tmpfile}`" 1031 done
836 if [ "${istar:0:9}" == "POSIX tar" ] ; then 1032 [[ -n ${nols} ]] \
837 istar=1 1033 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1034 export LINGUAS=${newls:1}
1035}
1036
1037# @FUNCTION: preserve_old_lib
1038# @USAGE: <libs to preserve> [more libs]
1039# @DESCRIPTION:
1040# These functions are useful when a lib in your package changes ABI SONAME.
1041# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1042# would break packages that link against it. Most people get around this
1043# by using the portage SLOT mechanism, but that is not always a relevant
1044# solution, so instead you can call this from pkg_preinst. See also the
1045# preserve_old_lib_notify function.
1046preserve_old_lib() {
1047 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1048 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1049 die "Invalid preserve_old_lib() usage"
1050 fi
1051 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1052
1053 # let portage worry about it
1054 has preserve-libs ${FEATURES} && return 0
1055
1056 local lib dir
1057 for lib in "$@" ; do
1058 [[ -e ${ROOT}/${lib} ]] || continue
1059 dir=${lib%/*}
1060 dodir ${dir} || die "dodir ${dir} failed"
1061 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1062 touch "${D}"/${lib}
1063 done
1064}
1065
1066# @FUNCTION: preserve_old_lib_notify
1067# @USAGE: <libs to notify> [more libs]
1068# @DESCRIPTION:
1069# Spit helpful messages about the libraries preserved by preserve_old_lib.
1070preserve_old_lib_notify() {
1071 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1072 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1073 die "Invalid preserve_old_lib_notify() usage"
1074 fi
1075
1076 # let portage worry about it
1077 has preserve-libs ${FEATURES} && return 0
1078
1079 local lib notice=0
1080 for lib in "$@" ; do
1081 [[ -e ${ROOT}/${lib} ]] || continue
1082 if [[ ${notice} -eq 0 ]] ; then
1083 notice=1
1084 ewarn "Old versions of installed libraries were detected on your system."
1085 ewarn "In order to avoid breaking packages that depend on these old libs,"
1086 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1087 ewarn "in order to remove these old dependencies. If you do not have this"
1088 ewarn "helper program, simply emerge the 'gentoolkit' package."
1089 ewarn
1090 fi
1091 # temp hack for #348634 #357225
1092 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1093 ewarn " # revdep-rebuild --library '${lib}'"
1094 done
1095 if [[ ${notice} -eq 1 ]] ; then
1096 ewarn
1097 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1098 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1099 for lib in "$@" ; do
1100 ewarn " # rm '${lib}'"
1101 done
1102 fi
1103}
1104
1105# @FUNCTION: built_with_use
1106# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1107# @DESCRIPTION:
1108#
1109# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1110#
1111# A temporary hack until portage properly supports DEPENDing on USE
1112# flags being enabled in packages. This will check to see if the specified
1113# DEPEND atom was built with the specified list of USE flags. The
1114# --missing option controls the behavior if called on a package that does
1115# not actually support the defined USE flags (aka listed in IUSE).
1116# The default is to abort (call die). The -a and -o flags control
1117# the requirements of the USE flags. They correspond to "and" and "or"
1118# logic. So the -a flag means all listed USE flags must be enabled
1119# while the -o flag means at least one of the listed IUSE flags must be
1120# enabled. The --hidden option is really for internal use only as it
1121# means the USE flag we're checking is hidden expanded, so it won't be found
1122# in IUSE like normal USE flags.
1123#
1124# Remember that this function isn't terribly intelligent so order of optional
1125# flags matter.
1126built_with_use() {
1127 local hidden="no"
1128 if [[ $1 == "--hidden" ]] ; then
1129 hidden="yes"
1130 shift
1131 fi
1132
1133 local missing_action="die"
1134 if [[ $1 == "--missing" ]] ; then
1135 missing_action=$2
1136 shift ; shift
1137 case ${missing_action} in
1138 true|false|die) ;;
1139 *) die "unknown action '${missing_action}'";;
1140 esac
1141 fi
1142
1143 local opt=$1
1144 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1145
1146 local PKG=$(best_version $1)
1147 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1148 shift
1149
1150 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1151 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1152
1153 # if the IUSE file doesn't exist, the read will error out, we need to handle
1154 # this gracefully
1155 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1156 case ${missing_action} in
1157 true) return 0;;
1158 false) return 1;;
1159 die) die "Unable to determine what USE flags $PKG was built with";;
1160 esac
1161 fi
1162
1163 if [[ ${hidden} == "no" ]] ; then
1164 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1165 # Don't check USE_EXPAND #147237
1166 local expand
1167 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1168 if [[ $1 == ${expand}_* ]] ; then
1169 expand=""
1170 break
1171 fi
1172 done
1173 if [[ -n ${expand} ]] ; then
1174 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1175 case ${missing_action} in
1176 true) return 0;;
1177 false) return 1;;
1178 die) die "$PKG does not actually support the $1 USE flag!";;
1179 esac
1180 fi
1181 fi
1182 fi
1183
1184 local USE_BUILT=$(<${USEFILE})
1185 while [[ $# -gt 0 ]] ; do
1186 if [[ ${opt} = "-o" ]] ; then
1187 has $1 ${USE_BUILT} && return 0
1188 else
1189 has $1 ${USE_BUILT} || return 1
1190 fi
1191 shift
1192 done
1193 [[ ${opt} = "-a" ]]
1194}
1195
1196# @FUNCTION: epunt_cxx
1197# @USAGE: [dir to scan]
1198# @DESCRIPTION:
1199# Many configure scripts wrongly bail when a C++ compiler could not be
1200# detected. If dir is not specified, then it defaults to ${S}.
1201#
1202# http://bugs.gentoo.org/73450
1203epunt_cxx() {
1204 local dir=$1
1205 [[ -z ${dir} ]] && dir=${S}
1206 ebegin "Removing useless C++ checks"
1207 local f
1208 find "${dir}" -name configure | while read f ; do
1209 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1210 done
1211 eend 0
1212}
1213
1214# @FUNCTION: make_wrapper
1215# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1216# @DESCRIPTION:
1217# Create a shell wrapper script named wrapper in installpath
1218# (defaults to the bindir) to execute target (default of wrapper) by
1219# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1220# libpaths followed by optionally changing directory to chdir.
1221make_wrapper() {
1222 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1223 local tmpwrapper=$(emktemp)
1224 # We don't want to quote ${bin} so that people can pass complex
1225 # things as $bin ... "./someprog --args"
1226 cat << EOF > "${tmpwrapper}"
1227#!/bin/sh
1228cd "${chdir:-.}"
1229if [ -n "${libdir}" ] ; then
1230 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1231 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
838 else 1232 else
839 istar=0 1233 export LD_LIBRARY_PATH="${libdir}"
840 fi
841
842 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
843 #dd if=${src} ibs=${metaskip} count=1 \
844 # | dd ibs=${tailskip} skip=1 \
845 # | gzip -dc \
846 # > ${datafile}
847 if [ ${iscompressed} -eq 1 ] ; then
848 if [ ${istar} -eq 1 ] ; then
849 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
850 | head -c $((${metaskip}-${tailskip})) \
851 | tar -xzf -
852 else
853 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
854 | head -c $((${metaskip}-${tailskip})) \
855 | gzip -dc \
856 > ${datafile}
857 fi 1234 fi
1235fi
1236exec ${bin} "\$@"
1237EOF
1238 chmod go+rx "${tmpwrapper}"
1239 if [[ -n ${path} ]] ; then
1240 (
1241 exeinto "${path}"
1242 newexe "${tmpwrapper}" "${wrapper}"
1243 ) || die
858 else 1244 else
859 if [ ${istar} -eq 1 ] ; then 1245 newbin "${tmpwrapper}" "${wrapper}" || die
860 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
861 | head -c $((${metaskip}-${tailskip})) \
862 | tar --no-same-owner -xf -
863 else
864 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
865 | head -c $((${metaskip}-${tailskip})) \
866 > ${datafile}
867 fi 1246 fi
868 fi
869 true
870 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
871 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
872} 1247}
873 1248
874# Unpack those pesky makeself generated files ... 1249# @FUNCTION: path_exists
875# They're shell scripts with the binary package tagged onto 1250# @USAGE: [-a|-o] <paths>
876# the end of the archive. Loki utilized the format as does 1251# @DESCRIPTION:
877# many other game companies. 1252# Check if the specified paths exist. Works for all types of paths
878# 1253# (files/dirs/etc...). The -a and -o flags control the requirements
879# Usage: unpack_makeself [file to unpack] [offset] 1254# of the paths. They correspond to "and" and "or" logic. So the -a
880# - If the file is not specified then unpack will utilize ${A}. 1255# flag means all the paths must exist while the -o flag means at least
881# - If the offset is not specified then we will attempt to extract 1256# one of the paths must exist. The default behavior is "and". If no
882# the proper offset from the script itself. 1257# paths are specified, then the return value is "false".
883unpack_makeself() { 1258path_exists() {
884 local src="`find_unpackable_file $1`" 1259 local opt=$1
885 local skip="$2" 1260 [[ ${opt} == -[ao] ]] && shift || opt="-a"
886 1261
887 local shrtsrc="`basename ${src}`" 1262 # no paths -> return false
888 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1263 # same behavior as: [[ -e "" ]]
889 if [ -z "${skip}" ] 1264 [[ $# -eq 0 ]] && return 1
890 then 1265
891 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`"
892 local skip=0 1266 local p r=0
1267 for p in "$@" ; do
1268 [[ -e ${p} ]]
1269 : $(( r += $? ))
1270 done
1271
893 case ${ver} in 1272 case ${opt} in
894 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1273 -a) return $(( r != 0 )) ;;
895 skip=`grep -a ^skip= ${src} | cut -d= -f2` 1274 -o) return $(( r == $# )) ;;
896 ;;
897 2.0|2.0.1)
898 skip=`grep -a ^$'\t'tail ${src} | awk '{print $2}' | cut -b2-`
899 ;;
900 2.1.1)
901 skip=`grep -a ^offset= ${src} | awk '{print $2}' | cut -b2-`
902 let skip="skip + 1"
903 ;;
904 2.1.2)
905 skip=`grep -a ^offset= ${src} | awk '{print $3}' | head -n 1`
906 let skip="skip + 1"
907 ;;
908 2.1.3)
909 skip=`grep -a ^offset= ${src} | awk '{print $3}'`
910 let skip="skip + 1"
911 ;;
912 *)
913 eerror "I'm sorry, but I was unable to support the Makeself file."
914 eerror "The version I detected was '${ver}'."
915 eerror "Please file a bug about the file ${shrtsrc} at"
916 eerror "http://bugs.gentoo.org/ so that support can be added."
917 die "makeself version '${ver}' not supported"
918 ;;
919 esac
920 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
921 fi
922
923 # lets grab the first few bytes of the file to figure out what kind of archive it is
924 local tmpfile="`mymktemp ${T}`"
925 tail -n +${skip} ${src} 2>/dev/null | head -c 512 > ${tmpfile}
926 local filetype="`file -b ${tmpfile}`"
927 case ${filetype} in
928 *tar\ archive)
929 tail -n +${skip} ${src} | tar --no-same-owner -xf -
930 ;;
931 bzip2*)
932 tail -n +${skip} ${src} | bzip2 -dc | tar --no-same-owner -xf -
933 ;;
934 gzip*)
935 tail -n +${skip} ${src} | tar --no-same-owner -xzf -
936 ;;
937 *)
938 false
939 ;;
940 esac 1275 esac
941 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
942} 1276}
943 1277
944# Display a license for user to accept. 1278# @FUNCTION: in_iuse
1279# @USAGE: <flag>
1280# @DESCRIPTION:
1281# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1282# as necessary.
945# 1283#
946# Usage: check_license [license] 1284# Note that this function should not be used in the global scope.
947# - If the file is not specified then ${LICENSE} is used. 1285in_iuse() {
948check_license() { 1286 debug-print-function ${FUNCNAME} "${@}"
1287 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1288
949 local lic=$1 1289 local flag=${1}
950 if [ -z "${lic}" ] ; then 1290 local liuse=( ${IUSE} )
951 lic="${PORTDIR}/licenses/${LICENSE}" 1291
952 else 1292 has "${flag}" "${liuse[@]#[+-]}"
953 if [ -e "${PORTDIR}/licenses/${src}" ] ; then 1293}
954 lic="${PORTDIR}/licenses/${src}" 1294
955 elif [ -e "${PWD}/${src}" ] ; then 1295# @FUNCTION: use_if_iuse
956 lic="${PWD}/${src}" 1296# @USAGE: <flag>
957 elif [ -e "${src}" ] ; then 1297# @DESCRIPTION:
958 lic="${src}" 1298# Return true if the given flag is in USE and IUSE.
959 fi 1299#
1300# Note that this function should not be used in the global scope.
1301use_if_iuse() {
1302 in_iuse $1 || return 1
1303 use $1
1304}
1305
1306# @FUNCTION: usex
1307# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1308# @DESCRIPTION:
1309# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1310# otherwise echo [false output][false suffix] (defaults to "no").
1311usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1312
1313# @FUNCTION: makeopts_jobs
1314# @USAGE: [${MAKEOPTS}]
1315# @DESCRIPTION:
1316# Searches the arguments (defaults to ${MAKEOPTS}) and extracts the jobs number
1317# specified therein. i.e. if the user has MAKEOPTS=-j9, this will show "9".
1318# We can't return the number as bash normalizes it to [0, 255]. If the flags
1319# haven't specified a -j flag, then "1" is shown as that is the default `make`
1320# uses. Useful for running non-make tools in parallel too.
1321makeopts_jobs() {
1322 [[ $# -eq 0 ]] && set -- ${MAKEOPTS}
1323 local x jobs
1324 for x ; do [[ ${x} == -j* ]] && jobs=${x#-j} ; done
1325 echo ${jobs:-1}
1326}
1327
1328check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1329
960 fi 1330fi
961 [ ! -f "${lic}" ] && die "Could not find requested license ${src}"
962 local l="`basename ${lic}`"
963
964 # here is where we check for the licenses the user already
965 # accepted ... if we don't find a match, we make the user accept
966 local alic
967 for alic in "${ACCEPT_LICENSE}" ; do
968 [ "${alic}" == "*" ] && return 0
969 [ "${alic}" == "${l}" ] && return 0
970 done
971
972 local licmsg="`mymktemp ${T}`"
973 cat << EOF > ${licmsg}
974**********************************************************
975The following license outlines the terms of use of this
976package. You MUST accept this license for installation to
977continue. When you are done viewing, hit 'q'. If you
978CTRL+C out of this, the install will not run!
979**********************************************************
980
981EOF
982 cat ${lic} >> ${licmsg}
983 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
984 einfon "Do you accept the terms of this license (${l})? [yes/no] "
985 read alic
986 case ${alic} in
987 yes|Yes|y|Y)
988 return 0
989 ;;
990 *)
991 echo;echo;echo
992 eerror "You MUST accept the license to continue! Exiting!"
993 die "Failed to accept license"
994 ;;
995 esac
996}
997
998# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
999# the whole 'non-interactive' policy, but damnit I want CD support !
1000#
1001# with these cdrom functions we handle all the user interaction and
1002# standardize everything. all you have to do is call cdrom_get_cds()
1003# and when the function returns, you can assume that the cd has been
1004# found at CDROM_ROOT.
1005#
1006# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1007# etc... if you want to give the cds better names, then just export
1008# the CDROM_NAME_X variables before calling cdrom_get_cds().
1009#
1010# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1011#
1012# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1013# - this will attempt to locate a cd based upon a file that is on
1014# the cd ... the more files you give this function, the more cds
1015# the cdrom functions will handle
1016cdrom_get_cds() {
1017 # first we figure out how many cds we're dealing with by
1018 # the # of files they gave us
1019 local cdcnt=0
1020 local f=
1021 for f in "$@" ; do
1022 cdcnt=$((cdcnt + 1))
1023 export CDROM_CHECK_${cdcnt}="$f"
1024 done
1025 export CDROM_TOTAL_CDS=${cdcnt}
1026 export CDROM_CURRENT_CD=1
1027
1028 # now we see if the user gave use CD_ROOT ...
1029 # if they did, let's just believe them that it's correct
1030 if [ ! -z "${CD_ROOT}" ] ; then
1031 export CDROM_ROOT="${CD_ROOT}"
1032 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1033 return
1034 fi
1035 # do the same for CD_ROOT_X
1036 if [ ! -z "${CD_ROOT_1}" ] ; then
1037 local var=
1038 cdcnt=0
1039 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1040 cdcnt=$((cdcnt + 1))
1041 var="CD_ROOT_${cdcnt}"
1042 if [ -z "${!var}" ] ; then
1043 eerror "You must either use just the CD_ROOT"
1044 eerror "or specify ALL the CD_ROOT_X variables."
1045 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1046 die "could not locate CD_ROOT_${cdcnt}"
1047 fi
1048 export CDROM_ROOTS_${cdcnt}="${!var}"
1049 done
1050 export CDROM_ROOT=${CDROM_ROOTS_1}
1051 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1052 return
1053 fi
1054
1055 if [ ${CDROM_TOTAL_CDS} -eq 1 ] ; then
1056 einfon "This ebuild will need the "
1057 if [ -z "${CDROM_NAME}" ] ; then
1058 echo "cdrom for ${PN}."
1059 else
1060 echo "${CDROM_NAME}."
1061 fi
1062 echo
1063 einfo "If you do not have the CD, but have the data files"
1064 einfo "mounted somewhere on your filesystem, just export"
1065 einfo "the variable CD_ROOT so that it points to the"
1066 einfo "directory containing the files."
1067 echo
1068 else
1069 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1070 cdcnt=0
1071 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1072 cdcnt=$((cdcnt + 1))
1073 var="CDROM_NAME_${cdcnt}"
1074 [ ! -z "${!var}" ] && einfo " CD ${cdcnt}: ${!var}"
1075 done
1076 echo
1077 einfo "If you do not have the CDs, but have the data files"
1078 einfo "mounted somewhere on your filesystem, just export"
1079 einfo "the following variables so they point to the right place:"
1080 einfon ""
1081 cdcnt=0
1082 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1083 cdcnt=$((cdcnt + 1))
1084 echo -n " CD_ROOT_${cdcnt}"
1085 done
1086 echo
1087 einfo "Or, if you have all the files in the same place, or"
1088 einfo "you only have one cdrom, you can export CD_ROOT"
1089 einfo "and that place will be used as the same data source"
1090 einfo "for all the CDs."
1091 echo
1092 fi
1093 export CDROM_CURRENT_CD=0
1094 cdrom_load_next_cd
1095}
1096
1097# this is only used when you need access to more than one cd.
1098# when you have finished using the first cd, just call this function.
1099# when it returns, CDROM_ROOT will be pointing to the second cd.
1100# remember, you can only go forward in the cd chain, you can't go back.
1101cdrom_load_next_cd() {
1102 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1103 local var=
1104
1105 unset CDROM_ROOT
1106 var=CDROM_ROOTS_${CDROM_CURRENT_CD}
1107 if [ -z "${!var}" ] ; then
1108 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1109 cdrom_locate_file_on_cd ${!var}
1110 else
1111 export CDROM_ROOT="${!var}"
1112 fi
1113
1114 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1115}
1116
1117# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1118# functions. this should *never* be called from an ebuild.
1119# all it does is try to locate a give file on a cd ... if the cd isn't
1120# found, then a message asking for the user to insert the cdrom will be
1121# displayed and we'll hang out here until:
1122# (1) the file is found on a mounted cdrom
1123# (2) the user hits CTRL+C
1124cdrom_locate_file_on_cd() {
1125 while [ -z "${CDROM_ROOT}" ] ; do
1126 local dir="$(dirname ${@})"
1127 local file="$(basename ${@})"
1128 local mline=""
1129 local showedmsg=0
1130
1131 for mline in `mount | egrep -e '(iso|cdrom)' | awk '{print $3}'` ; do
1132 [ -d "${mline}/${dir}" ] || continue
1133 [ ! -z "$(find ${mline}/${dir} -iname ${file} -maxdepth 1)" ] \
1134 && export CDROM_ROOT=${mline}
1135 done
1136
1137 if [ -z "${CDROM_ROOT}" ] ; then
1138 echo
1139 if [ ${showedmsg} -eq 0 ] ; then
1140 if [ ${CDROM_TOTAL_CDS} -eq 1 ] ; then
1141 if [ -z "${CDROM_NAME}" ] ; then
1142 einfo "Please insert the cdrom for ${PN} now !"
1143 else
1144 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1145 fi
1146 else
1147 if [ -z "${CDROM_NAME_1}" ] ; then
1148 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1149 else
1150 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1151 einfo "Please insert+mount the ${!var} cdrom now !"
1152 fi
1153 fi
1154 showedmsg=1
1155 fi
1156 einfo "Press return to scan for the cd again"
1157 einfo "or hit CTRL+C to abort the emerge."
1158 read
1159 fi
1160 done
1161}

Legend:
Removed from v.1.78  
changed lines
  Added in v.1.391

  ViewVC Help
Powered by ViewVC 1.1.20